import sys,pygame
from math import sin,cos
from random import random
pygame.init()
pygame.mixer.quit()     #This eats up a core of resources, so let's close it!
black=(0,0,0)
white=(255,255,255)

def window(width=800,height=600):
    return pygame.display.set_mode((width,height))

def pixel(screen,x,y,c,w=16,h=16):
  for i in range(w):
    for j in range(h):
      screen.set_at((x+i,y+j),c)

def tilepix(screen,pos,tile,color):
  x = ((pos[0] - 800 - 4 - 512 - 4)&0xFFF0)
  y = pos[1]&0xFFF0
  pixel(screen,x+800+4+512+4,y,color)
  cy = tile >> 4
  cx = tile & 15
  cy <<= 5
  cx <<= 5
  pixel(screen,(x>>2)+cx+800+4,cy+(y>>2),color,4,4)
  
def rand():
#  return random()
  return random()*2-1
def drawmap(screen,mapdata,tile):
  y = 0
  for i in mapdata:
    x = 0
    for j in i:
      screen.blit(pygame.transform.scale(tile[j],(16,16)),pygame.Rect(x,y,16,16))
      x += 16
    y += 16


# Initialize the window
screen=window(800+4+512+4+128,800)
screen.fill(white)

# Define rectangles
tiles = pygame.Rect(800+4,0,512,512)
tilemap = pygame.Rect(0,0,800,800)
edit = pygame.Rect(800+4+512+4,0,128,800)

# Load the tiles
timg = pygame.image.load("tiles.png")
tile = []
x = 0
y = 0
for k in range(256):
  img = pygame.Surface((8,8)).convert()
  img.blit(timg,(0,0),pygame.Rect(x,y,x+8,y+8))
  tile += [img]
  x += 8
  if x == 128:
      x = 0
      y += 8

# Load the desired map
mapname = "map0.txt"
try:
  f = open(mapname,'r')
  s = f.read().replace('\r','\n').replace('\n\n','\n').split('\n')
  f.close()
except:
  s = ['1','1','0']

mapw = int(s[0])
maph = int(s[1])
mapdata = []
for i in range(50):
  mapdata += [[0]*50]

for i in range(maph):
  r = s[i+2].split(',')
  for j in range(len(r)):
    mapdata[i][j] = int(r[j])

drawmap(screen,mapdata,tile)

t = pygame.transform.scale(timg,(512,512))
screen.blit(t,tiles)
for y in range(800):
  for k in range(2):
    screen.set_at((801+k,y),black)
    screen.set_at((801+4+512+k,y),black)

# Display it in the tile editor menu
screen.blit(pygame.transform.scale(tile[0],(128,128)),edit)


pygame.display.flip()
draw = False
tileselected = False
curtile = 0
tilesedited = False
tilesedited = True
last_x = 0
last_y = 0
color  = black
kup = True

while 1:
    pygame.time.wait(10)
    for event in pygame.event.get():
        if event.type == pygame.QUIT:
          # screenshot
          pygame.image.save(screen,"tilemap.png")

          # Save the tilesheet
          if tilesedited:
            x = 0
            y = 0
            for i in range(256):
              timg.blit(tile[i],pygame.Rect(x,y,x+8,y+8))
              x += 8
              if x == 128:
                x = 0
                y += 8
            pygame.image.save(timg,"tiles.png")
          
          # Save the tilemap
          # Get the dimensions of the map
          x = 0
          y = 0
          a = 0
          for i in mapdata:
            c = 0
            k = 0
            for j in i:
              if j != 0:
                c = k
              k += 1
            if c != 0:
              y = a
            a += 1
            if c>x:
              x = c
          x += 1
          y += 1
          s = str(x)+'\n'+str(y)
          for i in mapdata[0:y]:
            t = '\n'
            for j in i[0:x]:
              t += str(j)+','
            s += t[0:-1]
          f = open(mapname,'w')
          f.write(s)
          f.close()
          print("saved "+mapname)
          sys.exit()
        elif event.type == pygame.MOUSEBUTTONDOWN:
          if event.button == 1:
            #Check if we are hovering over the map editor
            #tile editor, or tile select
            if event.pos[0]<800:
              # map editor
              #need to map pos to map coords
              x = event.pos[0]>>4
              y = event.pos[1]>>4

              #edit map data
              mapdata[y][x] = curtile
              
              #draw tile
              screen.blit(pygame.transform.scale(tile[curtile],(16,16)),pygame.Rect(x<<4,y<<4,16,16))
              
              pygame.display.flip()

            elif event.pos[0]<800+4+512:
              # tile selector
              curtile = ((event.pos[0]-800-4)>>5) + (((event.pos[1])>>5)<<4)

              # Now we need to display it in the tile editor menu
              screen.blit(pygame.transform.scale(tile[curtile],(128,128)),edit)
              
              pygame.display.flip()

            else:
              # tile editor
              last_x = event.pos[0]
              last_y = event.pos[1]
              if y<128:
                if screen.get_at(event.pos)[0] == 0:
                  color = white
                else:
                  color = black

                tilepix(screen,event.pos,curtile,color)

                # Need to tilepix the pixel
                i = (curtile + (last_y>>7))&255
                y = last_y&0x70
                x = (last_x - 800-4-512-4)&0x70
                y >>= 4
                x >>= 4
                tile[i].set_at((x,y),color)

                #Need to redraw the map
                drawmap(screen,mapdata,tile)

                pygame.display.flip()
            draw = True
        elif event.type == pygame.MOUSEBUTTONUP:
          if event.button == 1:
            draw = False
        elif event.type == pygame.MOUSEMOTION and draw:
            if event.pos[0]<800:
              # map editor
              #need to map pos to map coords
              x = event.pos[0]>>4
              y = event.pos[1]>>4

              #edit map data
              mapdata[y][x] = curtile
              
              #draw tile
              screen.blit(pygame.transform.scale(tile[curtile],(16,16)),pygame.Rect(x<<4,y<<4,16,16))
              
              pygame.display.flip()
            elif event.pos[0]<800+4+512:
              pass
            else:
              if abs(event.pos[0] - last_x) >= 16 or abs(event.pos[1] - last_y) >= 16:
                last_x = event.pos[0]
                last_y = event.pos[1]
                if last_y <128:
                  tilepix(screen,event.pos,curtile,color)

                  # Need to tilepix the pixel
                  i = (curtile + (last_y>>7))&255
                  y = last_y&0x70
                  x = (last_x - 800-4-512-4)&0x70
                  y >>= 4
                  x >>= 4
                  tile[i].set_at((x,y),color)

                  #Need to redraw the map
                  drawmap(screen,mapdata,tile)

                  pygame.display.flip()
        elif event.type == pygame.KEYDOWN and kup:
          kup = False
          if event.unicode == u's':
            # screenshot
            pygame.image.save(screen,"tilemap.png")

            # Save the tilesheet
            if tilesedited:
              x = 0
              y = 0
              for i in range(256):
                timg.blit(tile[i],pygame.Rect(x,y,x+8,y+8))
                x += 8
                if x == 128:
                  x = 0
                  y += 8
              pygame.image.save(timg,"tiles.png")
          
            # Save the tilemap
            # Get the dimensions of the map
            x = 0
            y = 0
            a = 0
            for i in mapdata:
              c = 0
              k = 0
              for j in i:
                if j != 0:
                  c = k
                k += 1
              if c != 0:
                y = a
              a += 1
              if c>x:
                x = c
            s = str(x+1)+'\n'+str(y+1)
            for i in mapdata[0:y+1]:
              t = '\n'
              for j in i[0:x+1]:
                t += str(j)+','
              s += t[0:-1]
            f = open(mapname,'w')
            f.write(s)
            f.close()
            print("saved "+mapname)
          elif event.unicode == u'l':
            mapname = raw_input("Map : ")
            try:
              f = open(mapname,'r')
              s = f.read().replace('\r','\n').replace('\n\n','\n').split('\n')
              f.close()
            except:
              s = ['1','1','0']
            mapw = int(s[0])
            maph = int(s[1])
            mapdata = []
            for i in range(50):
              mapdata += [[0]*50]

            for i in range(maph):
              r = s[i+2].split(',')
              for j in range(len(r)):
                mapdata[i][j] = int(r[j])

            drawmap(screen,mapdata,tile)
            pygame.display.flip()

        elif event.type == pygame.KEYUP:
          kup = True


